# -*- coding: utf-8 -*-
from setuphelpers import *
import re 

r"""
Usable WAPT package functions: install(), uninstall(), session_setup(), audit(), update_package()
 {
   "key":"{DB942AEA-93D6-4FE4-8862-180D35A76030}",
   "name":"Belgium e-ID middleware 5.1.8 (build 6030)",
   "version":"5.1.6030",
   "install_date":"2024-06-14 00:00:00",
   "install_location":"C:\\Program Files (x86)\\Belgium Identity Card\\",
   "uninstall_string":"MsiExec.exe /I{DB942AEA-93D6-4FE4-8862-180D35A76030}",
   "publisher":"Belgian Government",
   "system_component":0,
   "win64":true
  }
 ]

"""
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls


def install():
    # Declaring local variables
    bin_name= glob.glob('Belgium%20eID-*.exe')[0]
    # Installing the software
   
    install_exe_if_needed(bin_name,
        silentflags='/S /allusers',
        key= '{DB942AEA-93D6-4FE4-8862-180D35A76030}',
        min_version=control.get_software_version(),
        get_version=get_version,
        timeout=600,
    )


def get_version(app_registry_dict):
    name = app_registry_dict.get("name", "")
    
    # Rechercher le motif pour la version 'X.X.X' et le build '(build XXXX)'
    version_match = re.search(r'\b\d+\.\d+\.\d+\b', name)
    build_match = re.search(r'build (\d+)', name)
    
    if version_match and build_match:
        version = version_match.group(0)
        build = build_match.group(1)
        return f"{version}.{build}"
    else:
        return None
